<div [ngClass]="['preview-table', jds.card, jds.rounded(0), jds.mb(20)]">
  <div [ngClass]="[jds.cardBody, jds.p(0)]">
    <div
      #main
      [ngClass]="[jds.tableResponsive, className.main]"
    >
      <table
        [ngClass]="[jds.table, className.table, jds.tableStriped, jds.fs(14)]"
        role="table"
        aria-label="Core Data"
        aria-describedby="Table Core Data"
      >
        <thead>
          <tr>
            <th
              class="table-head"
              *ngFor="let head of metadata; let i = index"
              [isSortable]="!head.disabled"
              [currentSort]="{
                sort: filter.sort,
                direction: filter.directory
              }"
              [ngClass]="[
                head.disabled ? 'disabled' : '',
                head.column === 'long50' ? className.column50 : '',
                head.column === 'long40' ? className.column40 : '',
                head.column === 'long30' ? className.column30 : '',
                head.column === 'short' ? className.columnShort : '',
                head.key === 'id' ? className.columnId : ''
              ]"
              [column]="head.key"
              [colorCustom]="true"
              (filterSort)="filterSort(head.disabled, head.key)"
              scope="col"
              jdsBiTableHead
              colorScheme="#FFF"
            >
              {{ head.key }}
            </th>
          </tr>
          <tr>
            <td *ngFor="let head of metadata; let i = index; let last = last">
              <ng-container *ngIf="head.type === 'freetext'">
                <div [ngClass]="[className.search]">
                  <input
                    #search
                    [colorScheme]="colorScheme"
                    (keyup)="filterSearch(head.key, $event)"
                    jdsBiInput
                    name="cari"
                    type="text"
                    placeholder="Cari"
                  />
                </div>
              </ng-container>
              <ng-container *ngIf="head.type === 'select'">
                <div [ngClass]="[className.select]">
                  <ng-select
                    #select
                    #getModelValue="ngModel"
                    [(ngModel)]="
                      filter.select[getFilterIndex('select', head.key)].value
                    "
                    [positioning]="mainEl"
                    [isLast]="last"
                    [searchable]="false"
                    [clearable]="true"
                    [readonly]="head.disabled"
                    [multiple]="true"
                    [closeOnSelect]="true"
                    [items]="head.value"
                    (change)="filterSelect(head.key, head.value, $event)"
                    bindValue="value"
                    bindLabel="label"
                    placeholder="Filter"
                    appendTo=".{{ className.main }}"
                  >
                    <ng-template ng-header-tmp>
                      <div class="ng-dropdown-search">
                        <div
                          [ngClass]="[
                            jds.formCheck,
                            jds.d('flex'),
                            jds.alignItems('center')
                          ]"
                        >
                          <input
                            [ngClass]="[
                              jds.formCheckInput,
                              jds.mt(0),
                              jds.me(10)
                            ]"
                            [checked]="
                              filter.select[getFilterIndex('select', head.key)]
                                .all
                            "
                            (change)="
                              filterSelectAll(
                                getModelValue,
                                head.key,
                                head.value,
                                $event.target.checked
                              )
                            "
                            type="checkbox"
                          />
                          <label
                            [ngClass]="[jds.formCheckLabel]"
                            [style.flexGrow]="1"
                          >
                            <input
                              [colorScheme]="colorScheme"
                              [placeholder]="'Cari'"
                              (input)="select.filter($event.target.value)"
                              jdsBiInput
                              type="text"
                            />
                          </label>
                        </div>
                      </div>
                    </ng-template>
                    <ng-template
                      ng-option-tmp
                      let-item="item"
                      let-item$="item$"
                      let-index="index"
                    >
                      <div [ngClass]="[jds.formCheck]">
                        <input
                          id="item-{{ index }}"
                          [(ngModel)]="item$.selected"
                          [ngClass]="[jds.formCheckInput]"
                          [ngModelOptions]="{ standalone: true }"
                          type="checkbox"
                          name="selectCheckbox"
                        />
                        <label
                          [ngClass]="[jds.formCheckLabel]"
                          for="item-{{ index }}"
                        >
                          {{ item.label }}
                        </label>
                      </div>
                    </ng-template>
                    <ng-template
                      ng-multi-label-tmp
                      let-items="items"
                    >
                      <div class="ng-value">
                        <span class="ng-value-label">
                          {{ items.length }} Filter
                        </span>
                      </div>
                    </ng-template>
                  </ng-select>
                </div>
              </ng-container>
            </td>
          </tr>
        </thead>
        <tbody>
          <ng-container *ngIf="isLoadingList$ | async">
            <tr *ngFor="let row of [0, 1, 2, 3, 4]">
              <td *ngFor="let head of metadata; let i = index">
                <div class="wrapper-skeleton">
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '100%',
                      'border-radius': '0',
                      height: '18px',
                      'margin-bottom': '0px',
                      'margin-top': '10px'
                    }"
                  />
                </div>
              </td>
            </tr>
          </ng-container>

          <ng-container *ngIf="(isLoadingList$ | async) === false">
            <ng-container *ngIf="(data$ | async)?.length > 0">
              <tr *ngFor="let row of data$ | async; let i = index">
                <td *ngFor="let head of metadata; let i = index">
                  {{ row[head.key] }}
                </td>
              </tr>
            </ng-container>

            <ng-container *ngIf="(data$ | async)?.length === 0">
              <tr>
                <td [attr.colspan]="metadata.length">Data tidak ditemukan.</td>
              </tr>
            </ng-container>
          </ng-container>
        </tbody>
      </table>
    </div>

    <ng-container *ngIf="(isLoadingList$ | async) === false">
      <ng-container *ngIf="(data$ | async)?.length > 0">
        <jds-bi-pagination
          [colorScheme]="'blue'"
          [perPageItems]="perPageItems"
          [pagination]="pagination$ | async"
          [perPage]="filter.perPage"
          [page]="filter.currentPage"
          (filterPerPage)="filterPerPage($event)"
          (filterPage)="filterPage($event)"
        />
      </ng-container>
    </ng-container>
  </div>
</div>
